<template>
    <div v-bind:class="{tcontainer: true, absolute: absoluteLayout}" :data-table-id="id">
        <!-- absolute layout -->
        <template v-if="absoluteLayout">
            <div class="abs-header" ref="header">
                <MdTable>
                    <Header
                            :lang="lang"
                            :columns="columns" @sort="sort" :ascending="sortAscending"
                            :sorted-column="this.sortedColumn"
                            :headerClass="this.headerClass"
                            :mark-sorted-column="this.markSortedColumn"
                    />
                </MdTable>
            </div>
            <div class="abs-body" ref="body">
                <div v-if="empty()" class="emptyCls">
                    <slot name="empty">no data</slot>
                </div>
                <MdTable v-else>
                    <MdTableRow
                            v-bind:id="`row${rowKey(row)}`"
                            v-bind:key="rowKey(row)"
                            v-for="(row, index) in effectiveRows"
                            @click="rowClicked(row)"
                            v-bind:class="{odd: markEvenOdd && index % 2 === 1 }"
                    >
                        <slot :row="row" />
                    </MdTableRow>
                    <Header :columns="columns" emptyRow />
                </MdTable>
            </div>
            <div class="abs-footer" v-if="pageSize !== rows.length">
                <Paginator :size="pageSize" :rows="sorted" :page.sync="page" ref="paginator"/>
            </div>
        </template>
        <!-- flow layout -->
        <template v-else>
            <div v-if="empty()" class="emptyCls">
                <slot name="empty">{{$t('empty')}}</slot>
            </div>
            <MdTable v-else>
                <Header
                        :columns="columns"
                        :headerClass="this.headerClass"
                        @sort="sort"
                        :ascending="sortAscending"
                        :sorted-column="this.sortedColumn"
                        :mark-sorted-column="this.markSortedColumn"
                />
                <MdTableRow
                        v-bind:key="rowKey(row)"
                        v-for="(row, index) in effectiveRows"
                        @click="rowClicked(row)"
                        v-bind:class="{odd: markEvenOdd && index % 2 === 1 }"
                >
                    <slot :row="row" />
                </MdTableRow>
                <Paginator v-if="pageSize !== rows.length" :size="pageSize" :rows="sorted" :page.sync="page" ref="paginator" />
            </MdTable>
        </template>
    </div>
</template>
<script>
  import Vue from 'vue';
  import jsLog from 'js-logger';
  import { MdTable } from 'vue-material/dist/components'
  import Header from './Header.vue';
  import { getScrollbarWidth } from '../../Helper';
  import { setInstance, releaseInstance } from './TableRegistry';
  import i18n from './i18n';
  import Paginator from './Paginator';

  let ID = 1;

  const log = jsLog.get('Table');

  Vue.use(MdTable);

  /* eslint-disable no-debugger */
  export default {
    props: {
      rows: {
        type: Array,
        isRequired: true
      },
      rowKey: {
        type: Function,
        isRequired: true
      },
      absoluteLayout: {
        type: Boolean
      },
      lang: {
        type: String
      },
      markSortedColumn: {
        type: Boolean,
        default: true
      },
      markEvenOdd:{
        type: Boolean,
        default: true
      },
      headerClass: {
        type: String,
        isRequired: false,
        default: undefined
      },
      paginate: {
        type: [Boolean, Number],
        default: false
      }
    },
    i18n,
    data() {
      return {
        columns: [],
        sortedColumn: undefined,
        sortAscending: true,
        id: ID++,
        page: 1,
        pageSize: this.initialPageSize()
      }
    },
    watch: {
      lang(locale) {
        this.$i18n.locale = locale;
      }
    },
    computed: {
      sorted() {
        if (!this.sortedColumn) return this.rows;
        const sortedColObject = this.columns.find(column => column.field === this.sortedColumn);
        if (!sortedColObject) return this.rows;
        const sortedRows = [...this.rows];
        console.log(`refresh sortedRows, sort ${this.ascDescLabel} by ${this.sortedColumn}`);
        const { field, sort, value } = sortedColObject;

        const comparator = (a, b) => {
          let valuea = value ? value(a) : a[field];
          let valueb = value ? value(b) : b[field];
          if (typeof sort === 'function') {
            valuea = sort(valuea);
            valueb = sort(valueb);
          }
          if (valuea === valueb) return 0;
          const asc = valuea > valueb ? 1 : -1;
          return this.sortAscending ? asc : -asc;
        };
        sortedRows.sort(comparator);
        return sortedRows;
      },
      effectiveRows(){
        const raw = this.sorted;
        if(!this.paginate) return raw;
        const size = this.pageSize;
        return raw.slice((this.page - 1) * size, this.page * size);
      },
      ascDescLabel() {
        return this.sortAscending ? 'ascending' : 'descending';
      }
    },
    components: {
      Header, Paginator
    },
    methods: {
      async paginateHighlightAndScrollInto(id){
        if(this.absoluteLayout) {
          let index = this.sorted.findIndex(row => this.rowKey(row) == id);
          if (index > -1) {
            this.page = Math.ceil((index + 1) / this.pageSize)
          }
          await this.$nextTick();
        }
        const row = document.querySelector(`#row${id}`);
        if(row){
          row.scrollIntoView();
          row.classList.add('highlighting');
          await new Promise(res => setTimeout(res, 1000));
          row.classList.remove('highlighting');
          return row;
        }
      },
      initialPageSize(){
        if(!this.paginate) return 0;
        if(this.absoluteLayout){
          if(this.paginate === true || this.paginate === 'auto') {
            return 10;
          } else {
            return this.paginate || 10;
          }
        } else {
          return this.paginate === true ? 5 : this.paginate;
        }
      },
      rowClicked(row) {
        this.$emit('rowClicked', row);
      },
      registerColumn(column, parentId) {
        if(this.id !== parentId) return;
        if (this.columns.find(({ field }) => field === column.field)) return;
        this.columns.push(column);
      },
      beforeUpdateColumn(column) {
        const col = this.columns.find(({ field }) => column.field === field);
        if(!col) return;
        col.label = column.label;
      },
      resize( updated) {
        log.info('resize');
        if (!this.absoluteLayout) return;
        const { body, header } = this.$refs;
        const viewHeight = body.clientHeight;
        const innerHeight = body.firstChild.clientHeight;
        const scrolls = innerHeight > viewHeight;
        const width = `${getScrollbarWidth()}px`;
        if (scrolls) header.style.paddingRight = width;
        else header.style.paddingRight = '0px';
        if(!this.paginate) return;
        const size = this.paginate;
        if(size || size === 'auto') {
          const rowHeight = window.innerWidth < 600 ? 50 : 72;
          const perPage = Math.floor(viewHeight / rowHeight );
          log.info('pageSize', perPage);
          this.pageSize = perPage;
        }
        if(!updated) {
          this.page = 1;
          this.$refs.paginator.navigated(1);
        }
      },
      empty() {
        return !this.rows || this.rows.length === 0;
      },
      sort({ field }) {
        if (this.sortedColumn === field) {
          this.sortAscending = !this.sortAscending;
        } else this.sortAscending = true;
        log.info(`sort ${this.ascDescLabel}`);
        this.sortedColumn = field;
      }
    },
    mounted() {
      if (this.absoluteLayout) window.addEventListener('resize', this.resize);
      this.resize();
    },
    beforeDestroy() {
      if (this.absoluteLayout) window.removeEventListener('resize', this.resize);
      releaseInstance(this.id);
    },
    created() {
      log.info('create table', this.id);
      setInstance(this);
    }
  }
</script>
<style scoped>
    .tcontainer {
        overflow-y: hidden;
        display: flex;
        flex-direction: column;
        height: 100%;
    }

    .absolute {
        display: flex;
    }

    .abs-header {
        flex: 1 auto;
        max-height: 60px;
    }

    .abs-body {
        flex: 1000 1px;
        overflow-y: auto;
        position: relative;
        top: -4px;
    }

    .abs-footer{
        flex: 1 auto;
        max-height: 40px;
    }

    .emptyCls {
        margin: 10px 0px;
        text-align: center;
        width: 100%;
        font-style: italic;
    }

    .absolute .emptyCls {
        margin: 0;
        width: 100%;
        position: absolute;
        top: 50%;
    }
    .odd{
        background-color: var(--table-odd-bg-color);
    }
    .highlighting{
        background-color: var(--md-theme-default-fieldvariant);
    }
</style>
<style lang="scss">
    @import './variables.scss';
</style>
